package utility;

import java.io.BufferedReader;
import java.io.File;
import java.io.FileReader;
import java.io.IOException;
import java.time.LocalTime;
import java.util.ArrayList;
import java.util.Arrays;

import org.eclipse.paho.client.mqttv3.MqttException;
import org.json.JSONException;
import org.json.JSONObject;

import scenari.Automa;
import scenari.Scenari;

public class Esecutore extends Thread {

	private final Automa automa;
	private final Scenari scenari;
	final String DB_FOLDER = Scenari.RES_FOLDER + "db-scenari/";
	private File scenarioAttivo = null;
	private final ArrayList<File> filesRead = new ArrayList<File>();
	private boolean isDonePublishing = false;
	private int retryNum = 0;
	private int filesNum = 0;
	private ArrayList<File> allScenariFiles;
//	private boolean userWantsToChange = false;
	private UserChangeSync ucs;
	private boolean shouldFindNewScenario = true;
	private final String ESEC_CONF = Scenari.CONF_FOLDER+"esecutore.json";

	public Esecutore(/* Publisher publisher, MyQueue<Integer> codaVal, */ Automa automa, Scenari scenari) throws IOException, JSONException {
//		this.codaVal = codaVal;
//		this.valore = 0;
		this.automa = automa;
//		this.publisher = publisher;
//		this.outputSuono = outputSuono;
		this.scenari = scenari;
		this.ucs = new UserChangeSync(this);

		setup();
	}
	
	public UserChangeSync getUCS() {
		return ucs;
	}

	private void setup() throws IOException, JSONException {
//		imposto lo scenario attivo
		JSONObject json = new JSONObject(Helper.leggiFile(ESEC_CONF));
		String scenarioAttivo = json.getString("scenario-attivo");
		this.scenarioAttivo = getScenarioFile(scenarioAttivo);//FIXME se null e disabilitato da utente…
	}
//	private int numeroRighe = 0;

	public void run() {
//		qui ci va la business logic
		try {
			while (true) {
				if(shouldFindNewScenario) {
					LocalTime ora = LocalTime.now();
	//				if(!automa.waitForAntifurto())
					boolean unreadStatus = automa.unreadStatus;
	//				if(retryNum < filesNum || unreadStatus)
	//					System.out.println("will we skip? "+ automa.getAntifurto()  +" {o.o} "+ unreadStatus+" {o.o} "+  isDonePublishing +" {o.o} "+ (unreadStatus && automa.getAntifurto()) +" {o.o} "+ (!unreadStatus && automa.getAntifurto() && isDonePublishing));
					if ((unreadStatus && automa.getAntifurto())// se leggo lo stato per la prima volta e l'antifurto e'
																// attivo -> ciclo
							|| (!unreadStatus && automa.getAntifurto() && isDonePublishing))// se ho gia' letto lo stato e
																							// l'antifurto e' attivo e devo
																							// ancora pubblicare -> ciclo
						continue;
	//				else isDonePublishing = false;
					// l’antifurto è acceso
	//				FileReader fr = randomFileScenari();
					FileReader fr = null;
	//				System.out.println("user:"+ucs.getBoolean()+" done:"+isDonePublishing);
					if(!ucs.getBoolean()) {
						if(scenarioAttivo == null && !isDonePublishing)
							fr = randomFileScenari();
						else fr = new FileReader(scenarioAttivo);
					} else {
						try {
							while(ucs.getBoolean()) {
								wait();
							}
						} catch (InterruptedException e) {
							e.printStackTrace();
						}
						System.out.println(scenarioAttivo);
						fr = new FileReader(scenarioAttivo);
					}
	//				System.out.println("do we have a file? "+(fr != null));
					if (fr == null)// || numeroRighe == 0)
						continue;
					BufferedReader br = new BufferedReader(fr);// selezioniamo un file contenente i comandi
					String line = br.readLine();// su ogni linea si trova un nuovo comando, in ordine di tempo dal meno
												// recente al piu' recente
	//				numeroRighe--;
					while (line != null && line.isBlank()) {
						line = br.readLine();
	//					numeroRighe--;
					}
					LocalTime tempoCmd = LocalTime.now();
					boolean startedPublishing = false;
	//				String nomeLuce;
	//				String cmd;
	//				System.out.println("is entering? "+(line != null && (!isDonePublishing || ora.isBefore(tempoCmd))));
					while (line != null && (!isDonePublishing || ora.isBefore(tempoCmd)) && !ucs.getBoolean()) {
						ora = LocalTime.now();
	//					System.out.println("\tsecondo ciclo");
	
						JSONObject jline = new JSONObject(line);
						String[] time = jline.getString("tempo").split("-");
	//					System.out.println("using: "+line);
						if (time.length != 3) {
	//						System.out.println(jline.getString("tempo"));
							continue;
						}
						tempoCmd = LocalTime.of(Integer.valueOf(time[0]), Integer.valueOf(time[1]),
								Integer.valueOf(time[2]));// otteniamo [la data e] l’ora in cui è stato inviato quel comando
	
						LocalTime tempoAttuale = LocalTime.now();
						try {
							long waitingTime = Helper.timeDifference(tempoAttuale, tempoCmd) * 1000;
							if (waitingTime > 0) {
	//							System.out.println(tempoAttuale);
	//							System.out.println(tempoCmd);
	//							System.out.println("Waiting to execute command");
	//							long offset = ((Double) (Math.random() * 10)).intValue()*1000;//trova un valore tra 1 e 10 (*1000)
								// ThreadLocalRandom.current().nextLong(10000);
	//							if(offset%2 == 0) {
	//								waitingTime += offset;// + 1000;
	//							} else waitingTime -= offset;
	//							waitingTime += 1000;
	//							System.out.println(waitingTime);
								if (waitingTime > 1000) {
									System.out.println("will sleep for "+waitingTime/1000);
									Thread.sleep(waitingTime);
//									wait(waitingTime);
								}
	
	//							System.out.println("running...");
								startedPublishing = true;
	//							System.out.println("\tpublishing");
								String nomeLuce = jline.getString("luce");
								String cmd = jline.getString("cmd");
	//							System.out.println("to/"+Scenari.getMqttTree()+"gpio/"+nomeLuce);
	//							System.out.println("{cmd:"+cmd+"}");
	//							publisher.aggiungiComando("to/"+Scenari.getMqttTree()+"gpio/"+nomeLuce, "{cmd:"+cmd+"}");
								scenari.sendMqttMessage("to/" + Scenari.getMqttTree("gpio/" + nomeLuce),
										"{cmd:" + cmd + "}");
							} // else System.out.println("useless");
						} catch (InterruptedException | MqttException e) {
							e.printStackTrace();
						}
						line = br.readLine();
	//					numeroRighe--;
						if (line != null)
							while (line.isBlank()) {
								line = br.readLine();
								// numeroRighe--;
							}
						else
							isDonePublishing = true;
	//					System.out.println("should restart? "+line != null+" ; "+ora.isBefore(tempoCmd));
	//					System.out.println(line != null && ora.isBefore(tempoCmd));
	//					System.out.println("should restart? "+(line != null && (!isDonePublishing || ora.isBefore(tempoCmd))));
	//					System.out.println(startedPublishing);
					}
	//				now line == null so I'm done reading the file
	//				TODO something about this
					br.close();
					fr.close();
	//				System.out.println("Retries: "+retryNum+" ; "+filesNum);
					retryNum++;
					isDonePublishing = (startedPublishing && retryNum < filesNum);// if i havent published, I should retry
					scenarioAttivo = isDonePublishing ? null : scenarioAttivo;//FIXME non sono sicuro
	//				System.out.println("started? "+startedPublishing+" [O.O] "+isDonePublishing);
	//				numeroRighe = 0;
				}
			}
		} catch (IOException | JSONException e) {
			e.printStackTrace();
		}
	}

	synchronized void updateAvailableScenari() throws IOException {
		// Creating a File object for directory
		File directoryPath = new File(DB_FOLDER);
		// List of all files and directories
		final ArrayList<File> allScenariFiles = new ArrayList<File>(Arrays.asList(directoryPath.listFiles()));
		final ArrayList<File> filesList = new ArrayList<File>();
		for (File f : allScenariFiles) {
			if (f.toString().endsWith(".json"))
				filesList.add(f);
//					else System.out.println("scarto: "+f.toString());
		}
		this.allScenariFiles = filesList;
	}

	private synchronized FileReader randomFileScenari() throws IOException, JSONException {
		updateAvailableScenari();
		filesNum = allScenariFiles.size();
		if (filesNum == 0)
			return null;
		if (filesNum == 1) {
			File f = allScenariFiles.get(0);
			setScenarioAttivo(f);
//			numeroRighe = ((Long)(Files.lines(f.toPath()).count())).intValue();
			return new FileReader(f);
		}
		File chosenFile = null;
		int retryNum = -1;
		do {
			chosenFile = allScenariFiles.get(((Double) (Math.random() * filesNum)).intValue());
			retryNum ++;
			if(retryNum > filesNum)
				return null;
		} while (chosenFile == null || filesRead.contains(chosenFile));
		setScenarioAttivo(chosenFile);
		return new FileReader(chosenFile);
	}

	synchronized void setScenarioAttivo(File f) throws IOException, JSONException {
		JSONObject k = new JSONObject();
		k.put("scenario-attivo", getScenarioNome(f));
		Helper.scriviFile(k.toString(), ESEC_CONF);
		scenarioAttivo = f;
		filesRead.add(f);
	}

	public String getScenarioAttivo() {
		return isDonePublishing || scenarioAttivo == null ? null : getScenarioNome(scenarioAttivo);
	}

	public String getDataScenarioAttivo() {
		String nome = getScenarioAttivo();
		return getScenarioData(nome);
	}

	public String getScenarioData(String scenario) {
		if (scenario == null)
			return null;
		return scenario.substring(9, 19);
	}

	public String getScenarioNome(File f) {
		if(f == null)
			return "";
		String[] pathScenario = f.toString().split("/");
		return pathScenario[pathScenario.length - 1];
	}

	public String getScenarioData(File f) {
		return getScenarioData(getScenarioNome(f));
	}

	public ArrayList<File> getAllScenariAvailable() throws IOException {
		return allScenariFiles;
	}
	
	void setLoopCondition(boolean loop) {
		shouldFindNewScenario = loop;
	}
	
	File getScenarioFile(String nome) throws IOException {
		File scen = null;
		if(allScenariFiles == null)
			updateAvailableScenari();
		for(File f : allScenariFiles) {
			String path = f.toString();
			if(path.contains(nome)) {
				scen = f;
				break;
			}
		}
		return scen;
	}

//	public void cambiaScenarioAttivo(JSONObject scenario) throws IOException, JSONException {
//		this gets called when from webapp the user changes the scenario
//		System.out.println("prima funzione");
//		userWantsToChange = true;
//		cambiaScenarioAttivo2(scenario);
//	}
	
//	public synchronized void cambiaScenarioAttivo2(JSONObject scenario) throws IOException, JSONException {
//		System.out.println("seconda funzione");
//		updateAvailableScenari();
//		String scenarioNome = scenario.getString("nome");
//		File scen = null;
//		for(File f : allScenariFiles) {
//			String path = f.toString();
//			if(path.contains(scenarioNome)) {
//				scen = f;
//				break;
//			}
//		}
//		if(scen != null) {			
//			setScenarioAttivo(scen);
//		}
//		userWantsToChange = false;
//		System.out.println("fine");
//		notifyAll();
//	}

}
